class MiniSdk {
  constructor() {
    this.requestUrl = "https://gpartner.shshuguikj.cn"
    this.getParamUrl = "https://gapi.shshuguikj.cn"
    this.defaultConfig = {}
    this.session = null
    this.appAccountId = null
    this.adList = null
    this.videoAd = null
  }

  // 登录
  login(data) {
    const _this = this
    if (data == undefined) {
      console.warn("tip：调用该方法时请依照示例代码传入指定参数")
      return
    }
    const { success = () => {}, fail = () => {} } = data
    const successCallBack = success
    const failCallBack = fail
    if (data.params == undefined) {
      failCallBack(_this.setResponse(500, undefined, "缺少参数params字段"))
      return
    }
    const { pid, gid, isAd = false } = data.params
    if (pid == undefined) {
      failCallBack(_this.setResponse(500, undefined, "参数params内部缺少pid"))
      return
    }
    if (gid == undefined) {
      failCallBack(_this.setResponse(500, undefined, "参数params内部缺少gid"))
      return
    }
    _this.defaultConfig.pid = pid
    _this.defaultConfig.gid = gid
    _this.defaultConfig.mid = 10000
    _this.defaultConfig.p_mid = 1
    const idfa = localStorage.getItem("idfa")
    _this.defaultConfig.idfa = idfa ? idfa : _this.createIdfa()
    _this.defaultConfig.os = "android"
    const xhr = new XMLHttpRequest()
    xhr.open("POST", `${_this.requestUrl}/log/device`, true)
    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
    xhr.timeout = 3000
    xhr.ontimeout = function () {
      failCallBack(_this.setResponse(500, {}, "请求超时"))
    }
    xhr.onreadystatechange = function () {
      if (xhr.readyState == 4 && xhr.status == 200) {
        const { code, data, msg } = JSON.parse(xhr.responseText)
        if (code == 200) {
          xhr.open("POST", `${_this.requestUrl}/init`, true)
          xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
          xhr.onreadystatechange = function () {
            if (xhr.readyState == 4 && xhr.status == 200) {
              const { code, data, msg } = JSON.parse(xhr.responseText)
              if (code == 200) {
                _this.loginFun(successCallBack, failCallBack, isAd)
              } else {
                failCallBack(_this.setResponse(500, data, msg))
              }
            }
          }
          console.log("init请求参数", {
            pid: _this.defaultConfig.pid,
            gid: _this.defaultConfig.gid,
            mid: _this.defaultConfig.mid,
            p_mid: _this.defaultConfig.p_mid,
            idfa: _this.defaultConfig.idfa,
            os: _this.defaultConfig.os,
            tm: Date.parse(new Date()) / 1000,
          })
          xhr.send(
            _this.signData(
              {
                pid: _this.defaultConfig.pid,
                gid: _this.defaultConfig.gid,
                mid: _this.defaultConfig.mid,
                p_mid: _this.defaultConfig.p_mid,
                idfa: _this.defaultConfig.idfa,
                os: _this.defaultConfig.os,
                tm: Date.parse(new Date()) / 1000,
              },
              true
            )
          )
        } else {
          failCallBack(_this.setResponse(500, data, msg))
        }
      }
    }
    console.log("device请求参数", {
      pid: _this.defaultConfig.pid,
      gid: _this.defaultConfig.gid,
      mid: _this.defaultConfig.mid,
      p_mid: _this.defaultConfig.p_mid,
      idfa: _this.defaultConfig.idfa,
      os: _this.defaultConfig.os,
      tm: Date.parse(new Date()) / 1000,
      package_name: "",
      idfv: "",
    })
    xhr.send(
      _this.signData(
        {
          pid: _this.defaultConfig.pid,
          gid: _this.defaultConfig.gid,
          mid: _this.defaultConfig.mid,
          p_mid: _this.defaultConfig.p_mid,
          idfa: _this.defaultConfig.idfa,
          os: _this.defaultConfig.os,
          tm: Date.parse(new Date()) / 1000,
          package_name: "",
          idfv: "",
        },
        true
      )
    )
  }

  // 授权后的登录
  loginFun(successCallBack, failCallBack, isAd) {
    const _this = this
    qg.login({
      success: qgResponse => {
        const { session, appAccountId } = qgResponse.data
        _this.session = session
        _this.appAccountId = appAccountId
        const xhr = new XMLHttpRequest()
        xhr.open("POST", `${_this.requestUrl}/login`, true)
        xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
        xhr.timeout = 3000
        xhr.ontimeout = function () {
          failCallBack(_this.setResponse(500, {}, "请求超时"))
        }
        xhr.onreadystatechange = function () {
          if (xhr.readyState == 4 && xhr.status == 200) {
            const { code, data, msg } = JSON.parse(xhr.responseText)
            console.log("登录返回结果", data, msg)
            if (code == 200) {
              console.log("登录成功")
              const cpData = {
                game_name: data.game_name,
                access_token: data.access_token,
              }
              if (data.pid !== undefined) {
                _this.defaultConfig.pid = data.pid
              }
              if (data.gid !== undefined) {
                _this.defaultConfig.gid = data.gid
              }
              if (data.mid !== undefined) {
                _this.defaultConfig.mid = data.mid
              }
              if (data.p_mid !== undefined) {
                _this.defaultConfig.p_mid = data.p_mid
              }
              localStorage.setItem("uname", data.uname)
              localStorage.setItem("access_token", data.access_token)
              if (isAd) {
                const adData = {
                  pid: _this.defaultConfig.pid,
                  gid: _this.defaultConfig.gid,
                  tm: Date.parse(new Date()) / 1000,
                }
                adData.sign = _this.signData(adData)
                xhr.open("GET", `${_this.getParamUrl}/sdk/com/adv/list?${_this.signData(adData, true)}`, true)
                xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
                xhr.timeout = 3000
                xhr.ontimeout = function () {
                  failCallBack(_this.setResponse(500, {}, "请求超时"))
                }
                xhr.onreadystatechange = function () {
                  if (xhr.readyState == 4 && xhr.status == 200) {
                    const { code, data, msg } = JSON.parse(xhr.responseText)
                    if (code == 200) {
                      _this.adList = data
                      successCallBack(_this.setResponse(200, cpData, "登录成功"))
                    } else {
                      failCallBack(_this.setResponse(500, data, msg))
                    }
                  }
                }
                xhr.send()
              } else {
                successCallBack(_this.setResponse(200, cpData, "登录成功"))
              }
            } else {
              failCallBack(_this.setResponse(500, data, msg))
            }
          }
        }
        const requestData = {
          pid: _this.defaultConfig.pid,
          gid: _this.defaultConfig.gid,
          mid: _this.defaultConfig.mid,
          p_mid: _this.defaultConfig.p_mid,
          tm: Date.parse(new Date()) / 1000,
          os: _this.defaultConfig.os,
          idfa: _this.defaultConfig.idfa,
          idfv: "",
        }
        requestData.partner_login_data = JSON.stringify({
          uid: _this.appAccountId,
          session: _this.session,
        })
        requestData.sign = _this.signData(requestData)
        console.log("login请求参数", _this.signData(requestData, true, true))
        xhr.send(_this.signData(requestData, true, true))
      },
      fail: err => {
        console.log("qg登录失败" + JSON.stringify(err))
        failCallBack(_this.setResponse(500, err, err.errMsg))
      },
    })
  }

  // 角色信息上报
  submitRoleInfo(data) {
    const _this = this
    if (data == undefined) {
      console.warn("tip：调用该方法时请依照示例代码传入指定参数")
      return
    }
    const { success = () => {}, fail = () => {} } = data
    const successCallBack = success
    const failCallBack = fail
    if (data.params == undefined) {
      failCallBack(_this.setResponse(500, undefined, "缺少参数params字段"))
      return
    }
    if (data.params.info_type == undefined || data.params.info_type == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.info_type == undefined ? "params内部缺少info_type字段（上报类型）" : "info_type值不能为空"}`))
      return
    }
    if (data.params.server_id == undefined || data.params.server_id == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.server_id == undefined ? "params内部缺少server_id字段（服务器id）" : "server_id值不能为空"}`))
      return
    }
    if (data.params.server_name == undefined || data.params.server_name == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.server_name == undefined ? "params内部缺少server_name字段（服务器名称）" : "server_name值不能为空"}`))
      return
    }
    if (data.params.role_id == undefined || data.params.role_id == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_id == undefined ? "params内部缺少role_id字段（角色id）" : "role_id值不能为空"}`))
      return
    }
    if (data.params.role_name == undefined || data.params.role_name == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_name == undefined ? "params内部缺少role_name字段（角色名称）" : "role_name值不能为空"}`))
      return
    }
    if (data.params.role_level == undefined || data.params.role_level == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_level == undefined ? "params内部缺少role_level字段（角色等级）" : "role_level值不能为空"}`))
      return
    }
    if (data.params.role_createtime == undefined || data.params.role_createtime == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_createtime == undefined ? "params内部缺少role_createtime字段（角色创建时间）" : "role_createtime值不能为空"}`))
      return
    }
    if (data.params.role_gender == undefined || data.params.role_gender == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_gender == undefined ? "params内部缺少role_gender字段（角色性别）" : "role_gender值不能为空"}`))
      return
    }
    if (data.params.role_vip == undefined || data.params.role_vip == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_vip == undefined ? "params内部缺少role_vip字段（角色vip等级）" : "role_vip值不能为空"}`))
      return
    }
    if (data.params.role_balance == undefined || data.params.role_balance == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_balance == undefined ? "params内部缺少role_balance字段（角色余额）" : "role_balance值不能为空"}`))
      return
    }
    if (data.params.role_fightvalue == undefined || data.params.role_fightvalue == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_fightvalue == undefined ? "params内部缺少role_fightvalue字段（角色战斗力/战力值）" : "role_fightvalue值不能为空"}`))
      return
    }
    if (data.params.role_profession == undefined || data.params.role_profession == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_profession == undefined ? "params内部缺少role_profession字段（角色职业）" : "role_profession值不能为空"}`))
      return
    }
    if (data.params.role_partyname == undefined || data.params.role_partyname == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_partyname == undefined ? "params内部缺少role_partyname字段（角色帮派）" : "role_partyname值不能为空"}`))
      return
    }
    if ((data.params.info_type == "roleUplevel" && data.params.role_leveltime == undefined) || data.params.role_leveltime == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_leveltime == undefined ? "params内部缺少role_leveltime字段（角色升级时间）" : "role_leveltime值不能为空"}`))
      return
    }
    if ((data.params.info_type == "changeName" && data.params.role_oldname == undefined) || data.params.role_oldname == "") {
      failCallBack(_this.setResponse(500, undefined, `${data.params.role_oldname == undefined ? "params内部缺少role_oldname字段（角色旧名字）" : "role_oldname值不能为空"}`))
      return
    }
    const roleData = {
      pid: _this.defaultConfig.pid,
      gid: _this.defaultConfig.gid,
      mid: _this.defaultConfig.mid,
      p_mid: _this.defaultConfig.p_mid,
      tm: Date.parse(new Date()) / 1000,
      action: data.params.info_type,
      access_token: localStorage.getItem("access_token"),
      role_info: encodeURIComponent(JSON.stringify(data.params)),
      os: _this.defaultConfig.os,
      idfa: _this.defaultConfig.idfa,
    }
    roleData.sign = _this.signData(roleData)
    const xhr = new XMLHttpRequest()
    xhr.open("POST", `${_this.requestUrl}/log/role`, true)
    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
    xhr.timeout = 3000
    xhr.ontimeout = function () {
      failCallBack(_this.setResponse(500, {}, "请求超时"))
    }
    xhr.onreadystatechange = function () {
      if (xhr.readyState == 4 && xhr.status == 200) {
        const { code, data, msg } = JSON.parse(xhr.responseText)
        if (code == 200) {
          console.log("上报成功")
          successCallBack(_this.setResponse(code, data, "上报成功"))
        } else {
          console.log("上报失败")
          failCallBack(_this.setResponse(code, data, msg))
        }
      }
    }
    console.log("submitRole请求参数", roleData)
    xhr.send(_this.signData(roleData, true, true))
  }

  // 支付（余额消耗待测试）
  pay(data) {
    const _this = this
    if (data == undefined) {
      console.warn("tip：调用该方法时请依照示例代码传入指定参数")
      return
    }
    const { fail = () => {} } = data
    _this.payFailCallBack = fail
    if (data.params == undefined) {
      _this.payFailCallBack(_this.setResponse(500, undefined, "缺少参数params字段"))
      return
    }
    if (data.params.tm == undefined || data.params.tm == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.tm == undefined ? "params内部缺少tm字段" : "tm值不能为空"}`))
      return
    }
    if (data.params.role_id == undefined || data.params.role_id == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.role_id == undefined ? "params内部缺少role_id字段" : "role_id值不能为空"}`))
      return
    }
    if (data.params.role_name == undefined || data.params.role_name == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.role_name == undefined ? "params内部缺少role_name字段" : "role_name值不能为空"}`))
      return
    }
    if (data.params.role_level == undefined || data.params.role_level == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.role_level == undefined ? "params内部缺少role_level字段" : "role_level值不能为空"}`))
      return
    }
    if (data.params.server_id == undefined || data.params.server_id == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.server_id == undefined ? "params内部缺少server_id字段" : "server_id值不能为空"}`))
      return
    }
    if (data.params.server_name == undefined || data.params.server_name == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.server_name == undefined ? "params内部缺少server_name字段" : "server_name值不能为空"}`))
      return
    }
    if (data.params.amt == undefined || data.params.amt == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.amt == undefined ? "params内部缺少amt字段" : "amt值不能为空"}`))
      return
    }
    if (data.params.goods_name == undefined || data.params.goods_name == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.goods_name == undefined ? "params内部缺少goods_name字段" : "goods_name值不能为空"}`))
      return
    }
    if (data.params.game_order_no == undefined || data.params.game_order_no == "") {
      _this.payFailCallBack(_this.setResponse(500, undefined, `${data.params.game_order_no == undefined ? "params内部缺少game_order_no字段" : "game_order_no值不能为空"}`))
      return
    }
    const orderData = {
      pid: _this.defaultConfig.pid,
      gid: _this.defaultConfig.gid,
      mid: _this.defaultConfig.mid,
      p_mid: _this.defaultConfig.p_mid,
      tm: data.params.tm,
      os: _this.defaultConfig.os,
      idfa: _this.defaultConfig.idfa,
      access_token: localStorage.getItem("access_token"),
      role_id: data.params.role_id,
      role_name: data.params.role_name,
      role_level: data.params.role_level,
      server_id: data.params.server_id,
      server_name: data.params.server_name,
      amt: data.params.amt,
      game_order_no: data.params.game_order_no,
      goods_name: data.params.goods_name,
      game_ext: data.params.game_ext ? data.params.game_ext : "",
      partner_pay_data: JSON.stringify({
        os: _this.defaultConfig.os,
        appAccountId: _this.appAccountId,
        session: _this.session,
      }),
    }
    orderData.sign = _this.signData(orderData)
    console.warn("orderData请求参数", orderData)
    const xhr = new XMLHttpRequest()
    xhr.open("POST", `${_this.requestUrl}/order`, true)
    xhr.setRequestHeader("Content-type", "application/x-www-form-urlencoded")
    xhr.timeout = 3000
    xhr.ontimeout = function () {
      payFailCallBack(_this.setResponse(500, {}, "请求超时"))
    }
    xhr.onreadystatechange = function () {
      if (xhr.readyState == 4 && xhr.status == 200) {
        const { code, data, msg } = JSON.parse(xhr.responseText)
        if (code == 200) {
          const payParams = data.partner_data
          console.log("下单成功", payParams)
          _this.useNativePay(payParams)
        } else {
          payFailCallBack(_this.setResponse(code, data, msg))
        }
      }
    }
    xhr.send(_this.signData(orderData, true, true))
  }

  // 米大师支付
  useNativePay(data) {
    qg.pay({
      orderInfo: data,
      success: function (res) {
        console.log("支付成功", res)
      },
      fail: function (err) {
        console.log("支付失败", err)
      },
    })
  }

  // 主动分享
  goShare() {}

  // 创建激励视频
  createVideoAd(data) {
    const _this = this
    if (data == undefined) {
      console.warn("tip：调用该方法时请依照示例代码传入指定参数")
      return
    }
    const { success = () => {}, fail = () => {} } = data
    const successCallBack = success
    const failCallBack = fail

    if (data.params == undefined) {
      failCallBack(_this.setResponse(500, undefined, "缺少参数params字段"))
      return
    }
    const { scene } = data.params
    if (scene == undefined) {
      failCallBack(_this.setResponse(500, undefined, "缺少scene字段"))
      return
    }

    if (_this.adList["channel_adv"] == undefined) {
      console.log("未配置广告，请联系我方运营")
      failCallBack(_this.setResponse(500, {}, "未配置广告，请联系我方运营"))
      return
    }
    if (_this.adList["channel_adv"][scene] == undefined) {
      console.log("未找到对应场景的广告配置")
      failCallBack(_this.setResponse(500, {}, "未找到对应场景的广告配置"))
      return
    }

    const videoAdUnitId = _this.adList["channel_adv"][scene]["data"]["9"]["ad_id"]
    console.log("videoAdUnitId", videoAdUnitId)

    if (!videoAdUnitId) {
      console.log("视频广告参数没有配置")
      failCallBack(_this.setResponse(500, {}, "视频广告参数没有配置"))
      return
    }

    try {
      console.log("创建OPPO激励视频广告")
      _this.videoAd = qg.createRewardedVideoAd({
        adUnitId: videoAdUnitId,
      })
      _this.videoAd.load()
      _this.videoAd.show()
      _this.videoAd.onError(err => {
        console.log("onError:" + JSON.stringify(err))
        failCallBack(_this.setResponse(500, {}, JSON.stringify(err)))
      })
      _this.videoAd.onClose(res => {
        if (res.isEnded) {
          successCallBack(_this.setResponse(200, { isAward: true }, "用户看完广告，可给奖励"))
        } else {
          successCallBack(_this.setResponse(200, { isAward: false }, "用户提前关闭广告，不给予奖励"))
        }
      })
    } catch (error) {
      console.log("oppoRewardVideoAd error", error)
      failCallBack(_this.setResponse(500, {}, JSON.stringify(error)))
    }
  }

  // 生成idfa
  createIdfa() {
    const date = new Date()
    const num = parseInt(Math.random() * (9999 - 1000 + 1) + 1000000, 10)
    let idfa = "xiaomi"
    idfa += date.getFullYear()
    idfa += "-" + (date.getMonth() + 1)
    idfa += "-" + date.getDate()
    idfa += "-" + date.getHours()
    idfa += "-" + date.getMinutes()
    idfa += "-" + date.getSeconds()
    idfa += "-" + num
    localStorage.setItem("idfa", idfa)
    return idfa
  }

  // 签名 / 排序参数
  signData(queryObj, noMd5, hasSign) {
    const keyArr = Object.keys(queryObj)
    let str = ""
    keyArr.includes("sign")
      ? keyArr.splice(
          keyArr.findIndex(item => item === "sign"),
          1
        )
      : ""
    if (hasSign) {
      keyArr.push("sign")
    }
    keyArr.sort()
    for (let i = 0; i < keyArr.length; i += 1) {
      if (queryObj[keyArr[i]]) {
        str = `${str}&${keyArr[i]}=${queryObj[keyArr[i]]}`
      }
    }
    if (noMd5) {
      return `${str.substr(1)}`
    } else {
      return md5(`${str.substr(1)}&`)
    }
  }

  // 设置返回
  setResponse(code, data = {}, msg = "") {
    return {
      code,
      data,
      msg,
    }
  }
}

function md5RotateLeft(lValue, iShiftBits) {
  return (lValue << iShiftBits) | (lValue >>> (32 - iShiftBits))
}

function md5AddUnsigned(lX, lY) {
  let lX4, lY4, lX8, lY8, lResult
  lX8 = lX & 0x80000000
  lY8 = lY & 0x80000000
  lX4 = lX & 0x40000000
  lY4 = lY & 0x40000000
  lResult = (lX & 0x3fffffff) + (lY & 0x3fffffff)
  if (lX4 & lY4) {
    return lResult ^ 0x80000000 ^ lX8 ^ lY8
  }
  if (lX4 | lY4) {
    if (lResult & 0x40000000) {
      return lResult ^ 0xc0000000 ^ lX8 ^ lY8
    } else {
      return lResult ^ 0x40000000 ^ lX8 ^ lY8
    }
  } else {
    return lResult ^ lX8 ^ lY8
  }
}

function md5F(x, y, z) {
  return (x & y) | (~x & z)
}

function md5G(x, y, z) {
  return (x & z) | (y & ~z)
}

function md5H(x, y, z) {
  return x ^ y ^ z
}

function md5I(x, y, z) {
  return y ^ (x | ~z)
}

function md5FF(a, b, c, d, x, s, ac) {
  a = md5AddUnsigned(a, md5AddUnsigned(md5AddUnsigned(md5F(b, c, d), x), ac))
  return md5AddUnsigned(md5RotateLeft(a, s), b)
}

function md5GG(a, b, c, d, x, s, ac) {
  a = md5AddUnsigned(a, md5AddUnsigned(md5AddUnsigned(md5G(b, c, d), x), ac))
  return md5AddUnsigned(md5RotateLeft(a, s), b)
}

function md5HH(a, b, c, d, x, s, ac) {
  a = md5AddUnsigned(a, md5AddUnsigned(md5AddUnsigned(md5H(b, c, d), x), ac))
  return md5AddUnsigned(md5RotateLeft(a, s), b)
}

function md5II(a, b, c, d, x, s, ac) {
  a = md5AddUnsigned(a, md5AddUnsigned(md5AddUnsigned(md5I(b, c, d), x), ac))
  return md5AddUnsigned(md5RotateLeft(a, s), b)
}

function md5ConvertToWordArray(string) {
  let lWordCount
  let lMessageLength = string.length
  let lNumberOfWordsTemp1 = lMessageLength + 8
  let lNumberOfWordsTemp2 = (lNumberOfWordsTemp1 - (lNumberOfWordsTemp1 % 64)) / 64
  let lNumberOfWords = (lNumberOfWordsTemp2 + 1) * 16
  let lWordArray = Array(lNumberOfWords - 1)
  let lBytePosition = 0
  let lByteCount = 0
  while (lByteCount < lMessageLength) {
    lWordCount = (lByteCount - (lByteCount % 4)) / 4
    lBytePosition = (lByteCount % 4) * 8
    lWordArray[lWordCount] = lWordArray[lWordCount] | (string.charCodeAt(lByteCount) << lBytePosition)
    lByteCount++
  }
  lWordCount = (lByteCount - (lByteCount % 4)) / 4
  lBytePosition = (lByteCount % 4) * 8
  lWordArray[lWordCount] = lWordArray[lWordCount] | (0x80 << lBytePosition)
  lWordArray[lNumberOfWords - 2] = lMessageLength << 3
  lWordArray[lNumberOfWords - 1] = lMessageLength >>> 29
  return lWordArray
}

function md5WordToHex(lValue) {
  let WordToHexValue = ""
  let WordToHexValueTemp = ""
  let lByte
  let lCount
  for (lCount = 0; lCount <= 3; lCount++) {
    lByte = (lValue >>> (lCount * 8)) & 255
    WordToHexValueTemp = "0" + lByte.toString(16)
    WordToHexValue = WordToHexValue + WordToHexValueTemp.substr(WordToHexValueTemp.length - 2, 2)
  }
  return WordToHexValue
}

function md5Utf8Encode(string) {
  string = string.replace(/\r\n/g, "\n")
  let utftext = ""
  for (let n = 0; n < string.length; n++) {
    let c = string.charCodeAt(n)
    if (c < 128) {
      utftext += String.fromCharCode(c)
    } else if (c > 127 && c < 2048) {
      utftext += String.fromCharCode((c >> 6) | 192)
      utftext += String.fromCharCode((c & 63) | 128)
    } else {
      utftext += String.fromCharCode((c >> 12) | 224)
      utftext += String.fromCharCode(((c >> 6) & 63) | 128)
      utftext += String.fromCharCode((c & 63) | 128)
    }
  }
  return utftext
}

function md5(string) {
  let x = []
  let k
  let AA
  let BB
  let CC
  let DD
  let a
  let b
  let c
  let d
  let [S11, S12, S13, S14, S21, S22, S23, S24, S31, S32, S33, S34, S41, S42, S43, S44] = [7, 12, 17, 22, 5, 9, 14, 20, 4, 11, 16, 23, 6, 10, 15, 21]
  string = md5Utf8Encode(string)
  x = md5ConvertToWordArray(string)
  a = 0x67452301
  b = 0xefcdab89
  c = 0x98badcfe
  d = 0x10325476
  for (k = 0; k < x.length; k += 16) {
    AA = a
    BB = b
    CC = c
    DD = d
    a = md5FF(a, b, c, d, x[k + 0], S11, 0xd76aa478)
    d = md5FF(d, a, b, c, x[k + 1], S12, 0xe8c7b756)
    c = md5FF(c, d, a, b, x[k + 2], S13, 0x242070db)
    b = md5FF(b, c, d, a, x[k + 3], S14, 0xc1bdceee)
    a = md5FF(a, b, c, d, x[k + 4], S11, 0xf57c0faf)
    d = md5FF(d, a, b, c, x[k + 5], S12, 0x4787c62a)
    c = md5FF(c, d, a, b, x[k + 6], S13, 0xa8304613)
    b = md5FF(b, c, d, a, x[k + 7], S14, 0xfd469501)
    a = md5FF(a, b, c, d, x[k + 8], S11, 0x698098d8)
    d = md5FF(d, a, b, c, x[k + 9], S12, 0x8b44f7af)
    c = md5FF(c, d, a, b, x[k + 10], S13, 0xffff5bb1)
    b = md5FF(b, c, d, a, x[k + 11], S14, 0x895cd7be)
    a = md5FF(a, b, c, d, x[k + 12], S11, 0x6b901122)
    d = md5FF(d, a, b, c, x[k + 13], S12, 0xfd987193)
    c = md5FF(c, d, a, b, x[k + 14], S13, 0xa679438e)
    b = md5FF(b, c, d, a, x[k + 15], S14, 0x49b40821)
    a = md5GG(a, b, c, d, x[k + 1], S21, 0xf61e2562)
    d = md5GG(d, a, b, c, x[k + 6], S22, 0xc040b340)
    c = md5GG(c, d, a, b, x[k + 11], S23, 0x265e5a51)
    b = md5GG(b, c, d, a, x[k + 0], S24, 0xe9b6c7aa)
    a = md5GG(a, b, c, d, x[k + 5], S21, 0xd62f105d)
    d = md5GG(d, a, b, c, x[k + 10], S22, 0x2441453)
    c = md5GG(c, d, a, b, x[k + 15], S23, 0xd8a1e681)
    b = md5GG(b, c, d, a, x[k + 4], S24, 0xe7d3fbc8)
    a = md5GG(a, b, c, d, x[k + 9], S21, 0x21e1cde6)
    d = md5GG(d, a, b, c, x[k + 14], S22, 0xc33707d6)
    c = md5GG(c, d, a, b, x[k + 3], S23, 0xf4d50d87)
    b = md5GG(b, c, d, a, x[k + 8], S24, 0x455a14ed)
    a = md5GG(a, b, c, d, x[k + 13], S21, 0xa9e3e905)
    d = md5GG(d, a, b, c, x[k + 2], S22, 0xfcefa3f8)
    c = md5GG(c, d, a, b, x[k + 7], S23, 0x676f02d9)
    b = md5GG(b, c, d, a, x[k + 12], S24, 0x8d2a4c8a)
    a = md5HH(a, b, c, d, x[k + 5], S31, 0xfffa3942)
    d = md5HH(d, a, b, c, x[k + 8], S32, 0x8771f681)
    c = md5HH(c, d, a, b, x[k + 11], S33, 0x6d9d6122)
    b = md5HH(b, c, d, a, x[k + 14], S34, 0xfde5380c)
    a = md5HH(a, b, c, d, x[k + 1], S31, 0xa4beea44)
    d = md5HH(d, a, b, c, x[k + 4], S32, 0x4bdecfa9)
    c = md5HH(c, d, a, b, x[k + 7], S33, 0xf6bb4b60)
    b = md5HH(b, c, d, a, x[k + 10], S34, 0xbebfbc70)
    a = md5HH(a, b, c, d, x[k + 13], S31, 0x289b7ec6)
    d = md5HH(d, a, b, c, x[k + 0], S32, 0xeaa127fa)
    c = md5HH(c, d, a, b, x[k + 3], S33, 0xd4ef3085)
    b = md5HH(b, c, d, a, x[k + 6], S34, 0x4881d05)
    a = md5HH(a, b, c, d, x[k + 9], S31, 0xd9d4d039)
    d = md5HH(d, a, b, c, x[k + 12], S32, 0xe6db99e5)
    c = md5HH(c, d, a, b, x[k + 15], S33, 0x1fa27cf8)
    b = md5HH(b, c, d, a, x[k + 2], S34, 0xc4ac5665)
    a = md5II(a, b, c, d, x[k + 0], S41, 0xf4292244)
    d = md5II(d, a, b, c, x[k + 7], S42, 0x432aff97)
    c = md5II(c, d, a, b, x[k + 14], S43, 0xab9423a7)
    b = md5II(b, c, d, a, x[k + 5], S44, 0xfc93a039)
    a = md5II(a, b, c, d, x[k + 12], S41, 0x655b59c3)
    d = md5II(d, a, b, c, x[k + 3], S42, 0x8f0ccc92)
    c = md5II(c, d, a, b, x[k + 10], S43, 0xffeff47d)
    b = md5II(b, c, d, a, x[k + 1], S44, 0x85845dd1)
    a = md5II(a, b, c, d, x[k + 8], S41, 0x6fa87e4f)
    d = md5II(d, a, b, c, x[k + 15], S42, 0xfe2ce6e0)
    c = md5II(c, d, a, b, x[k + 6], S43, 0xa3014314)
    b = md5II(b, c, d, a, x[k + 13], S44, 0x4e0811a1)
    a = md5II(a, b, c, d, x[k + 4], S41, 0xf7537e82)
    d = md5II(d, a, b, c, x[k + 11], S42, 0xbd3af235)
    c = md5II(c, d, a, b, x[k + 2], S43, 0x2ad7d2bb)
    b = md5II(b, c, d, a, x[k + 9], S44, 0xeb86d391)
    a = md5AddUnsigned(a, AA)
    b = md5AddUnsigned(b, BB)
    c = md5AddUnsigned(c, CC)
    d = md5AddUnsigned(d, DD)
  }
  return (md5WordToHex(a) + md5WordToHex(b) + md5WordToHex(c) + md5WordToHex(d)).toLowerCase()
}

// GameGlobal.bhSdk = new MiniSdk()
export default MiniSdk
